package com.pact;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

public class NodePair {
    Node node1;
    Node node2;

    public NodePair(Node n1, Node n2) {
        this.node1 = n1;
        this.node2 = n2;
    }

    public static int getNodesSize(List<NodePair> node_pairs) {
        return node_pairs.get(0).nodesSize();
    }

    /**
     * Gets size of
     * @return size of node
     */
    public int nodesSize()
    {
        return this.node1.getVenn().length();
    }

    public String toString() {
        return "<" + this.node1 + ", " + this.node2 + ">";
    }

    public boolean equals(Object o) {
        NodePair input = (NodePair)o;
        return ((input.node1 == this.node1) && (input.node2 == this.node2)) || (
                (input.node1 == this.node2) && (input.node2 == this.node1));
    }

    public HashSet<Node> combineSubTrees() {
        List<Node> res = _combineSubTrees();
        return new HashSet(res);

    }

    public List<Node> _combineSubTrees() {
        System.out.println("combineSubTrees==========================");
        System.out.println("node1: " + node1.getVenn());
        System.out.println("node2: " + node2.getVenn());
        System.out.println("node1Full: " + node1.root().getVenn());
        System.out.println("node2Full: " + node2.root().getVenn());
        List<Node> commonSiblings = new ArrayList<>();

        List<Node> node1Siblings = new ArrayList<>(this.node1.getSiblings());
        Iterator it1 = node1Siblings.iterator();
        List<Node> node2Siblings = new ArrayList<>(this.node2.getSiblings());
        Iterator it2 = node2Siblings.iterator();

        StringBuilder siblingsVenn = new StringBuilder();

        if (!node1Siblings.isEmpty()) {
            siblingsVenn.append(((Node) it2.next()).getVenn());
        } else {
            if (it1.hasNext()) {
                siblingsVenn.append(((Node) it1.next()).getVenn());
                if (it1.hasNext()) {
                    String temp = siblingsVenn.toString();
                    siblingsVenn = new StringBuilder("(" + temp);
                    while (it1.hasNext()) {
                        siblingsVenn.append(((Node) it1.next()).getVenn());
                    }
                    siblingsVenn.append(")");
                }
                commonSiblings.add(new Node(null, siblingsVenn.toString()));
                return commonSiblings;
            }
            return commonSiblings;
        }

        if (it2.hasNext()) {
            String temp = siblingsVenn.toString();
            siblingsVenn = new StringBuilder("(" + temp);
            while (it2.hasNext()) {
                siblingsVenn.append(((Node) it2.next()).getVenn());
            }
            siblingsVenn.append(")");
        }

        Node nodesibs1 = new Node(null, siblingsVenn.toString());
        if (!it1.hasNext()) {
            commonSiblings.add(nodesibs1);
            return commonSiblings;
        }
        String siblings2 = "";
        if (it1.hasNext()) {
            siblings2 = siblings2 + ((Node)it1.next()).getVenn();
            if (it1.hasNext()) {
                String temp = siblings2;
                siblings2 = "(" + temp;
                while (it1.hasNext()) {
                    siblings2 = siblings2 + ((Node)it1.next()).getVenn();
                }
                siblings2 = siblings2 + ")";
            }
        }

        Node nodeSibs2 = new Node(null, siblings2);
        return new ArrayList(Node.combine(nodesibs1, nodeSibs2));
    }

    protected HashSet<NodePair> combineNew() {
        List<NodePair> setResult = new ArrayList<>();
        Node resultNode1 = new Node(null, this.node2.root().getVenn());
        String added = "(" + this.node2.getVenn() + this.node1.getVenn() + ")";

        for (Node linkNode : node2.linkNodes) {
            String result = buildUp(linkNode, added);
            Node resultNode2 = new Node(null, result);
            setResult.add(new NodePair(resultNode1, resultNode2));
        }
        return new HashSet(setResult);
    }

    private String buildUp(Node n, String s) {
        if (n.parent == null) {
            return s;
        } else {
            String result = s;
            for(Node sibling : n.getSiblings()){
                result +=  sibling.getVenn();
            }
            return buildUp(n.parent, "(" + result + ")");
        }
    }
}
